unit TestForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Ras,
  StdCtrls, ExtCtrls, ComCtrls,u_Errorlog, Menus, Oracle, Db, OracleData,
  Registry;

type
  TfrmTest = class(TForm)
    Timer1: TTimer;
    Edit4: TEdit;
    edt_ipverbindung: TEdit;
    edt_ipprovider: TEdit;
    lvConnections: TListView;
    Edit1: TEdit;
    connected: TCheckBox;
    edt_ende: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    edt_dauer: TEdit;
    Label3: TLabel;
    edt_beginn: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    MainMenu1: TMainMenu;
    Ende1: TMenuItem;
    Info1: TMenuItem;
    Verbindungen1: TMenuItem;
    Session: TOracleSession;
    OracleDataSet1: TOracleDataSet;
    Query: TOracleQuery;
    Registrierung1: TMenuItem;
    Einstellungen: TMenuItem;
    Label10: TLabel;
    edt_kosten: TEdit;
    Button1: TButton;
    procedure btnActiveConnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Ende1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Verbindungen1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Registrierung1Click(Sender: TObject);
    procedure EinstellungenClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Label9Click(Sender: TObject);
  private
    { Private declarations }
    //dialparams: TRasDialParams;
  public
    { Public declarations }
  end;

function TagImJahr(Datum:TDateTime):word;
procedure FeiertageBerechnen(Y:word);
function TryConnect:boolean;

const
  Feiertage : array [1..19] of string[25] =
   ('Neujahr','Maifeiertag','Tag der deutschen Einheit','Allerheiligen',
    'Totensonntag','Volkstrauertag','1. Weihnachtstag','2. Weihnachtstag',
    'Karfreitag','Ostersonntag','Ostermontag','Christi Himmelfahrt',
    'Pfingstsonntag','Pfingstmontag','Fronleichnam','Heilige 3 Knige',
    'Mari Himmelfahrt','Reformationstag','Bu- und Bettag');
  Sondertage : array [1..24] of string[25] =
   ('Mari Lichtme','Valentinstag','Weiberfastnacht','Rosenmontag','Fastnacht',
    'Aschermittwoch','Mari Verkndigung','Palmsonntag','Grndonnerstag','Muttertag',
    'Peter und Paul','Mari Geburt','Erntedankfest','Mari Empfngnis','Silvester',
    '1. Advent','2. Advent','3. Advent','4. Advent','Heiligabend','Frhlingsanfang',
    'Sommmeranfang','Herbstanfang','Winteranfang');
  Land:integer=1;
var
  Feiertag      : array [1..366] of ShortInt;
  frmTest: TfrmTest;
  b_connected:bool;
  start:TDateTime;
  user,password,service:string;
  oraconnect:bool;
  bRegistriert:bool;
  bmessage:bool;
implementation

uses info1, heute1, regsit1,u_tools, einstellung,ShellAPI, error1;
//Uses TeeAbout,TeeBasic,Features,UDemoCha,Specs

{$R *.DFM}


procedure TfrmTest.FormCreate(Sender: TObject);
var
  reg: TRegistry;
  i:integer;
  F: Textfile;
  s,s1,s2:string;
begin
  DateSeparator:='.';
  ShortDateFormat:='DD.MM.YY';
  ShortTimeFormat:='hh:mm:ss';
  user:='';
  bRegistriert:=false;
  Verbindungen1.enabled:=true;

  with Label9 do begin
    Font.Color:=clBlue;
    Font.Style:=[fsUnderline];
    Cursor:=crHandPoint;
  end;

  s:='20'+copy(datetimetostr(now),7,2); // jahreszahl
  FeiertageBerechnen(strtoint(s));

  reg:=TRegistry.Create;
  reg.RootKey:=HKEY_LOCAL_MACHINE;
  if reg.KeyExists('\SOFTWARE\watchy') then
  begin
    reg.OpenKey('\SOFTWARE\watchy',FALSE);
    try
      user:=reg.ReadString('user');
      password:=reg.ReadString('password');
      service:=reg.ReadString('database');
    except
      showmessage('error reading registry');
    end;
    reg.CloseKey;
  end;
  reg.Free;

  if user<>'' then begin // verbindung zu oracle aufbauen
    session.LogonUsername:=User;
    session.LogonPassword:=Password;
    session.LogonDatabase:=service;
    oraconnect:=tryconnect;
    if oraconnect=false then
      showmessage('keine Verbindung zu Oracle!');
  end;

  AssignFile(F,'key.bin');
  try
    Reset(F);
    readln(F,s);
    CloseFile (F);

    if(s[length(s)]='#') then begin
      s1:=copy(s,1,PosMidStr('#',s,1)-1);
      s2:=copy(s,PosMidStr('#',s,1)+1,length(s)-PosMidStr('#',s,1)-1);
      checkps(s2,s1);
    end;

  except
    bregistriert:=false;
  end;
end;

function TagImJahr(Datum:TDateTime):word;
var T,M,J  : word;
    Erster : TDateTime;
begin
  try
    DecodeDate(Datum,J,M,T);
    Erster:=EncodeDate(J,1,1);
    Result:=trunc(Datum-Erster+1);
  except
    Result:=0;
  end;
end;

procedure FeiertageBerechnen(Y:word);
var D,dw,OM,aw : word;
    Dat        : TDateTime;
    Ostern     : TDateTime;
    Weihnacht  : TDateTime;

Function OsterSonntag(Y:word):TDateTime;
var a,b,c,d,e,tag,monat : integer;
begin
  a:=y MOD 19 ;
  b:=y MOD 4;
  c:=y MOD 7;
  d:=(19*a+24) MOD 30;
  e:=(2*b+4*c+6*d+5) MOD 7;
  Tag:=22+d+e;
  monat:=3;
  IF Tag>31 then begin
    tag:=d+e-9;
    monat:=4;
  end;
  IF (tag=26) AND (monat=4) then
    tag:=19;
  IF (tag=25) AND (monat=4) AND (d=28) AND (e=6) AND (a>10) then
    tag:=18;
  try
    Result:= EncodeDate(y,monat,tag);
  except
    Result:=0;
  end;
end;

begin
  for D:=1 to 366 do
    Feiertag[D]:=0;
  Ostern:=OsterSonntag(Y);
  try
    DecodeDate(Ostern,Y,OM,D);
  except
    OM:=4;
  end;
  try
    Weihnacht:=EncodeDate(Y,12,25);
    if (DayOfWeek(Weihnacht)-1)=0 then
      dw:=7
    else
      dw:=DayOfWeek(Weihnacht)-1;
  except
    Weihnacht:=-1;
    dw:=0;
  end;
  {Mari Lichtme}                     {Sondertage}
  Dat:=Encodedate(Y,2,2);
  Feiertag[TagImJahr(Dat)]:=-1;
  {Valentinstag}
  Dat:=Encodedate(Y,2,14);
  Feiertag[TagImJahr(Dat)]:=-2;
  {Weiberfastnacht}
  Dat:=Ostern-45;
  while DayOfWeek(Dat)<>2 do
    Dat:=Dat-1;
  Feiertag[TagImJahr(Dat)-4]:=-3;
  {Rosenmontag}
  Feiertag[TagImJahr(Dat)]:=-4;
  {Fastnacht}
  Feiertag[TagImJahr(Dat)+1]:=-5;
  {Aschermittwoch}
  Feiertag[TagImJahr(Dat)+2]:=-6;
  {Mari Verkndigung}
  Dat:=Encodedate(Y,3,25);
  Feiertag[TagImJahr(Dat)]:=-7;
  {Palmsonntag}
  Feiertag[TagImJahr(Ostern)-7]:=-8;
  {Grndonnerstag}
  Feiertag[TagImJahr(Ostern)-3]:=-9;
  {Muttertag}
  Dat:=EncodeDate(y,4,30);
  aw:=DayOfWeek(Dat)-1;
  Dat:=Dat-aw+14;
  if Dat=(Ostern+49) then
    Dat:=Dat-7;
  Feiertag[TagImJahr(Dat)]:=-10;
  {Peter und Paul}
  Dat:=Encodedate(Y,6,29);
  Feiertag[TagImJahr(Dat)]:=-11;
  {Mari Geburt}
  Dat:=Encodedate(Y,9,8);
  Feiertag[TagImJahr(Dat)]:=-12;
  {Erntedankfest}
  Dat:=Encodedate(Y,10,1);
  while DayOfWeek(Dat)<>1 do
    Dat:=Dat+1;
  Feiertag[TagImJahr(Dat)]:=-13;
  {Mari Empfngnis}
  Dat:=Encodedate(Y,12,8);
  Feiertag[TagImJahr(Dat)]:=-14;
  {Silvester}
  Dat:=Encodedate(Y,12,31);
  Feiertag[TagImJahr(Dat)]:=-15;
  {1. Advent}
  Dat:=Weihnacht;
  while DayOfWeek(Dat)<>1 do
    Dat:=Dat-1;
  Feiertag[TagImJahr(Dat)-21]:=-16;
  {2. Advent}
  Feiertag[TagImJahr(Dat)-14]:=-17;
  {3. Advent}
  Feiertag[TagImJahr(Dat)-7]:=-18;
  {4. Advent}
  Feiertag[TagImJahr(Dat)]:=-19;
  {Heiligabend}
  Feiertag[TagImJahr(Weihnacht)-1]:=-20;
  {Frhlingsanfang}
  Dat:=Encodedate(Y,3,21);
  Feiertag[TagImJahr(Dat)]:=-21;
  {Sommmeranfang}
  Dat:=Encodedate(Y,6,21);
  Feiertag[TagImJahr(Dat)]:=-22;
  {Herbstanfang}
  Dat:=Encodedate(Y,9,23);
  Feiertag[TagImJahr(Dat)]:=-23;
  {Winteranfang}
  Dat:=Encodedate(Y,12,22);
  Feiertag[TagImJahr(Dat)]:=-24;
  {Neujahr}                         {Feiertage}
  Feiertag[1]:=1;
  {Maifeiertag}
  Dat:=Encodedate(Y,5,1);
  Feiertag[TagImJahr(Dat)]:=2;
  {Tag der deutschen Einheit}
  Dat:=Encodedate(Y,10,3);
  Feiertag[TagImJahr(Dat)]:=3;
  {Allerheiligen}
  Dat:=Encodedate(Y,11,1);
  Feiertag[TagImJahr(Dat)]:=4;
  {Totensonntag}
  if Weihnacht>=0 then
    Feiertag[TagImJahr(Weihnacht-dw-28)]:=5;
  {Bu- und Bettag}
  if land=12 then
    Feiertag[TagImJahr(Weihnacht-dw-32)]:=19;
  {Volkstrauertag}
  if Weihnacht>=0 then
    Feiertag[TagImJahr(Weihnacht-dw-35)]:=6;
  {1. Weihnachtstag}
  if Weihnacht>=0 then
    Feiertag[TagImJahr(Weihnacht)]:=7;
  {2. Weihnachtstag}
  if Weihnacht>=0 then
    Feiertag[TagImJahr(Weihnacht)+1]:=8;
  {Karfreitag}
  Feiertag[TagImJahr(Ostern)-2]:=9;
  {Ostersonntag}
  Feiertag[TagImJahr(Ostern)]:=10;
  {Ostermontag}
  Feiertag[TagImJahr(Ostern)+1]:=11;
  {Christi Himmelfahrt}
  Feiertag[TagImJahr(Ostern)+39]:=12;
  {Pfingstsonntag}
  Feiertag[TagImJahr(Ostern)+49]:=13;
  {Pfingstmontag}
  Feiertag[TagImJahr(Ostern)+50]:=14;
  {Fronleichnam}
  if (land<2) or ((land>=9) and (land<=12)) or (land=15) then
    Feiertag[TagImJahr(Ostern)+60]:=15;
  {Heilige 3 Knige}
  if (land=0) or (land=1) or (land=13) then
    Feiertag[6]:=16;
  {Mari Himmelfahrt}
  if (land=1) or (land=11) then begin
    Dat:=Encodedate(Y,8,15);
    Feiertag[TagImJahr(Dat)]:=17;
  end;
  {Reformationstag}
  if (land=3) or (land=7) or (land=12) or (land=13) or (land=15) then begin
    Dat:=Encodedate(Y,10,31);
    Feiertag[TagImJahr(Dat)]:=18;
  end;
end;

function StatusString(state: TRasConnState; error: Longint): String;
  var
    c: Array[0..100] of Char;
    s: String;
  begin
  if error <> 0 then
    begin
    RasGetErrorString(error, c, 100);
    Result := c;
    end
  else
    begin
    s := '';
    case State of
      RASCS_OpenPort:
        s := 'Opening port';
      RASCS_PortOpened:
        s := 'Port opened';
      RASCS_ConnectDevice:
        s := 'Connecting device';
      RASCS_DeviceConnected:
        s := 'Device connected';
      RASCS_AllDevicesConnected:
        s := 'All devices connected';
      RASCS_Authenticate:
        s := 'Start authenticating';
      RASCS_AuthNotify:
        s := 'Authentication: notify';
      RASCS_AuthRetry:
        s := 'Authentication: retry';
      RASCS_AuthCallback:
        s := 'Authentication: callback';
      RASCS_AuthChangePassword:
        s := 'Authentication: change password';
      RASCS_AuthProject:
        s := 'Authentication: projecting';
      RASCS_AuthLinkSpeed:
        s := 'Authentication: link speed';
      RASCS_AuthAck:
        s := 'Authentication: acknowledge';
      RASCS_ReAuthenticate:
        s := 'Authentication: reauthenticate';
      RASCS_Authenticated:
        s := 'Authenticated';
      RASCS_PrepareForCallback:
        s := 'Preparing for callback';
      RASCS_WaitForModemReset:
        s := 'Waiting for modem reset';
      RASCS_WaitForCallback:
        s := 'Waiting for callback';
      RASCS_Projected:
        s := 'Projected';
      RASCS_StartAuthentication:
        s := 'Start authentication';
      RASCS_CallbackComplete:
        s := 'Callback complete';
      RASCS_LogonNetwork:
        s := 'Logging on network';

      RASCS_Interactive:
        s := 'Interactive';
      RASCS_RetryAuthentication:
        s := 'Retry Authentication';
      RASCS_CallbackSetByCaller:
        s := 'Callback set by caller';
      RASCS_PasswordExpired:
        s := 'Password expired';

      RASCS_Connected:
        s := 'Connected';
      RASCS_Disconnected:
        s := 'Disconnected';
      end;
    Result := s;
    end;
  end;

function OraDate(t:TDateTime):string;
var s,fdate:string;
begin
  fdate:=ShortDateFormat;
  ShortDateFormat:='dd.MM.yyyy hh:mm:ss';
  s:=' to_date('''
       + dateToStr(t) + ' ' + ''','
       + '''DD.MM.YYYY HH24:MI:SS'''+') ';
  OraDate:=s;
  ShortDateFormat:=fdate;
end;

procedure TfrmTest.btnActiveConnClick(Sender: TObject);
  var
    bufsize: Longint;
    numEntries: Longint;
    x: Integer;
    entries: Array[1..100] of TRasConn;
    stat: TRasConnStatus;
    hip:TRASPPPIP;
    lpcb,temp:integer;
    s:string;
    dauer,ende:TTime;
    kosten:real;
  begin
  entries[1].dwSize := SizeOf(TRasConn);
  bufsize := SizeOf(TRasConn) * 100;
  lvConnections.Items.Clear;
  FillChar(stat, Sizeof(TRasConnStatus), 0);
  stat.dwSize := Sizeof(TRasConnStatus);
  if RasEnumConnections(@entries[1], bufsize, numEntries) = 0 then
  begin
    if numEntries > 0 then
    begin
      for x := 1 to numEntries do
        with lvConnections.Items.Add, entries[x] do
          begin
          lpcb:=1000;
          hip.dwsize:=sizeOf(TRASPPPIP);
          temp:=RasGetProjectionInfo(hrasconn,RASP_PppIp,@hip,lpcb);
          Data := Pointer(hrasconn);
          Caption := szEntryName;
          edit1.text:=szEntryName;
          //edit2.text:=szDeviceType;
          //edit3.text:=szDeviceName;
          RasGetConnectStatus(hrasconn, stat);
          edit4.text:=StatusString(stat.rasconnstate, stat.dwError);
          if stat.rasconnstate=$2000 then connected.checked:=true
                                     else connected.checked:=false;
          if hip.dwsize>0 then begin
            if b_connected=false then begin
              bmessage:=false;
              start:=now;
              edt_beginn.text:=DateTimeToStr(start);
              edt_ende.text:='';
              edt_kosten.text:='';
            end;
            b_connected:=true;
            edt_ipverbindung.text:=hip.szIpAddress;
            edt_ipprovider.text:=hip.szServerIpAddress;
            edt_dauer.text:=TimeToStr(now-start);
            edt_kosten.text:=floattostrf(berechnekosten(start,now,edit1.text),ffCurrency,5,2);
            Application.Title:=edit1.text+' : '+edt_dauer.text+' - '+edt_kosten.text;
          end;
         end;
      lvConnections.ItemFocused :=lvConnections.Items[0];
    end
    else begin
      if b_connected=true then begin
        connected.checked:=false;
        edit4.text:='offline';
        ende:=now;
        dauer:=ende-start;
        edt_ende.text:=DateTimeToStr(ende);
        edt_dauer.text:=TimeToStr(dauer);
        kosten:=berechnekosten(start,ende,edit1.text);
        edt_kosten.text:=floattostrf(kosten,ffCurrency,5,2);
        s:=ReplaceStr(',','.',edt_kosten.text);
        timer1.enabled:=false;
        werr('Provider : '+edit1.text
           +', IP-Verbindung : '+edt_ipverbindung.text
           +', IP-Provider : '+edt_ipprovider.text
           +', Beginn : '+edt_beginn.text
           +', Ende : '+edt_ende.text
           +', Dauer : '+TimeToStr(dauer)
           +', Kosten : '+s
           ,1);
        s:=ReplaceStr(' DM','',s);
        werr(edit1.text
           +','+edt_ipverbindung.text
           +','+edt_ipprovider.text
           +','+edt_beginn.text
           +','+edt_ende.text
           +','+TimeToStr(dauer)
           +','+s,2);
        if oraconnect=true then begin
          Query.sql.clear;
          s:='insert into watchy values('
           +#39+edit1.text+#39+','
           +#39+edt_ipverbindung.text+#39+','
           +#39+edt_ipprovider.text+#39+','
           +oradate(start)+','
           +oradate(ende)+')'
           +edt_kosten.text+')';
          Query.SQL.Add(s);
          Query.execute;
          session.commit;
        end;
        timer1.enabled:=true;
        if kosten=0 then begin
          if bmessage=false then
          error.show;
          bmessage:=true;
        end;
      end;
      b_connected:=false;
    end;
  end
  else
    ShowMessage('RasEnumConnections failed.');
  end;

procedure TfrmTest.Timer1Timer(Sender: TObject);
begin
 btnActiveConnClick(self);
end;

procedure TfrmTest.Ende1Click(Sender: TObject);
begin
  close;
end;

procedure TfrmTest.Info1Click(Sender: TObject);
begin
  info.show;
end;

procedure TfrmTest.Verbindungen1Click(Sender: TObject);
{
var
  i:integer;
  s:string;
  s1,s2:TTime;
}
begin
  heute.showmodal;
  {
  for i:=1 to heute.StringGrid1.RowCount do begin

          s1:=strtodatetime(heute.StringGrid1.Cells[3,i]);
          s2:=strtodatetime(heute.StringGrid1.Cells[4,i]);

          Query.sql.clear;
          s:='insert into watchy values('
           +#39+heute.StringGrid1.Cells[0,i]+#39+','
           +#39+heute.StringGrid1.Cells[1,i]+#39+','
           +#39+heute.StringGrid1.Cells[2,i]+#39+','
           +oradate(s1)+','
           +oradate(s2)+')';
          Query.SQL.Add(s);
          Query.execute;
          session.commit;

  end;
  }
end;

function TryConnect:boolean;
var
  io,ende:boolean;
  i:integer;
begin
  i:=0;
  TryConnect:=false;
  ende:=false;
  while not ende do
  begin
   Try
    frmTest.session.logon;
    io:=true;
   except
   io:=false
   end;
   inc(i);
   ende:=io or (i>=3);
 end;
 TryConnect:=io;
end;

procedure TfrmTest.FormDestroy(Sender: TObject);
begin
  if oraconnect then
    session.LogOff;
end;

procedure TfrmTest.Registrierung1Click(Sender: TObject);
begin
  regist.showmodal;
end;

procedure TfrmTest.EinstellungenClick(Sender: TObject);
begin
  einstell.showmodal;
end;

procedure TfrmTest.Button1Click(Sender: TObject);
begin
werr('test',1);
{
 edit1.text:='Lbecker';
 edt_beginn.text:='30.07.00 20:00:00';
 edt_ende.text:='30.07.00 20:05:00';
 edt_kosten.text:=floattostrf(berechnekosten(StrToDateTime(edt_beginn.text),StrToDateTime(edt_ende.text),edit1.text),ffCurrency,5,2);
 }
end;

{
Dazu nimmt man am besten eine TLabel-Komponente (hier: "URLLabel") und gestaltet
diese so, da sie wie ein Link im Browser erscheint (hier ist es die URL der
p.i.c.s.-Homepage):

 Caption:='http://pics-software.de';
 Font.Color:=clBlue;
 Font.Style:=[fsUnderline];
 Cursor:=crHandPoint;


function GetWindowsVersion:string; 
             var 
               OsVinfo   : TOSVERSIONINFO;
               HilfStr   : array[0..50] of Char; 
             begin 
               ZeroMemory(@OsVinfo,sizeOf(OsVinfo)); 
               OsVinfo.dwOSVersionInfoSize := sizeof(TOSVERSIONINFO); 
               if GetVersionEx(OsVinfo) then begin 
                 if OsVinfo.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS then  
                  begin 
                   if (OsVinfo.dwMajorVersion = 4) and  
                    (OsVinfo.dwMinorVersion > 0) then 
                     StrFmt(HilfStr,'Windows 98 - Version %d.%.2d.%d', 
                            [OsVinfo.dwMajorVersion, OsVinfo.dwMinorVersion,  
                             OsVinfo.dwBuildNumber AND $FFFF]) 
                   else 
                     StrFmt(HilfStr,'Windows 95 - Version %d.%d Build %d', 
                            [OsVinfo.dwMajorVersion, OsVinfo.dwMinorVersion,  
                             OsVinfo.dwBuildNumber AND $FFFF]); 
                 end; 
                 if OsVinfo.dwPlatformId = VER_PLATFORM_WIN32_NT then 
                   StrFmt(HilfStr,'Microsoft Windows NT Version %d.%.2d.%d', 
                          [OsVinfo.dwMajorVersion, OsVinfo.dwMinorVersion,  
                           OsVinfo.dwBuildNumber AND $FFFF]); 
               end 
               else 
                 StrCopy(HilfStr,'Fehler bei GetversionEx()!'); 
               Result:=string(HilfStr); 
             end;

 }
procedure TfrmTest.Label9Click(Sender: TObject);
begin

ShellExecute(Application.Handle, 'open',
              PCHar(Label9.Caption), nil, nil,
              SW_ShowNormal);
end;

end.
