unit einstellung;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Grids,u_tools, StdCtrls,u_errorlog,TestForm;

type
  TEinstell = class(TForm)
    StringGrid1: TStringGrid;
    MainMenu1: TMainMenu;
    zurck1: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    btn_neu: TButton;
    procedure zurck1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btn_neuClick(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

function Berechnekosten(start,ende:TTime;provdr:string):real;

var
  Einstell: TEinstell;
  provider:array [1..10] of string;
  taktung:array [1..10] of integer;
  zeitraum:array [1..10,1..16] of tdatetime;
  preis:array [1..10,1..16] of real;
  geaendert:bool;
implementation

{$R *.DFM}

procedure TEinstell.zurck1Click(Sender: TObject);
begin
  close;
end;

procedure TEinstell.FormCreate(Sender: TObject);
begin
  StringGrid1.Cells[0,0]:='Provider';
  StringGrid1.Cells[1,0]:='Tag';
  StringGrid1.Cells[2,0]:='von/bis';
  StringGrid1.Cells[3,0]:='Pf/min';
  StringGrid1.Cells[4,0]:='von/bis';
  StringGrid1.Cells[5,0]:='Pf/min';
  StringGrid1.Cells[6,0]:='von/bis';
  StringGrid1.Cells[7,0]:='Pf/min';
  StringGrid1.Cells[8,0]:='Taktung (s)';
  geaendert:=false;
  FormShow(self);
end;

procedure TEinstell.FormShow(Sender: TObject);
var
  i,k,l,p,spalte,ct:integer;
  F: Textfile;
  s,s1,temp:string;
begin
  AssignFile(F,'watchy.ini');
  try
    i:=1;
    Reset(F);
    while not Eof(F) do begin
      readln(F,s);   // provider
      k:=PosMidStr('#',s,1);
      provider[i]:=copy(s,1,k-1);
      StringGrid1.Cells[0,1+3*(i-1)]:=provider[i];
      taktung[i]:=strtoint(copy(s,k+1,length(s)-k));
      StringGrid1.Cells[8,1+3*(i-1)]:=inttostr(taktung[i]);

      for ct:= 0 to 2 do begin
        readln(F,s);   // wochtage
        k:=1;          // 00:00-08:00=2,9#08:00-18:00=3,9#18:00-24:00=2,9#
        l:=1;
        p:=1;
        spalte:=2;
        while (k<length(s)) do begin
          k:=PosMidStr('#',s,l);
          if k=0 then
            k:=length(s);
          s1:=copy(s,p,k-p+1);
          temp:=copy(s1,1,PosMidStr('=',s1,1)-1);
          StringGrid1.Cells[spalte,ct+1+3*(i-1)]:=temp;
          zeitraum[i,ct+1+(spalte-2)*2]:=strtotime(copy(temp,1,5)+':00');
          temp:=copy(s1,PosMidStr('=',s1,1)+1,length(s1)-PosMidStr('=',s1,1)-1);
          StringGrid1.Cells[spalte+1,ct+1+3*(i-1)]:=temp;
          preis[i,ct+1+(spalte-2)*2]:=strtofloat(temp);
          p:=k+1;
          l:=l+k;
          StringGrid1.Cells[1,1+3*(i-1)]:='Wochentag';
          StringGrid1.Cells[1,2+3*(i-1)]:='Samstag';
          StringGrid1.Cells[1,3+3*(i-1)]:='Feiertag';
          spalte:=spalte+2;
        end;
      end;
      inc(i);
      StringGrid1.rowcount:=(i-1)*3+1;
    end;
    CloseFile (F);
  except
    CloseFile (F);
  end;
end;

procedure TEinstell.Button2Click(Sender: TObject);
begin
  if geaendert=true then begin
    if (MessageDlg ('Wollen Sie Ihre nderungen wirklich verwerfen ? ',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
    close;
  end
  else
    close;
end;

procedure TEinstell.Button1Click(Sender: TObject);
var
  i,k:integer;
  init:bool;
  s:string;
begin
  FileCheck(GetFilePath+'watchy.ini',3);
  for i:=1 to StringGrid1.rowcount do begin
    if StringGrid1.Cells[0,i]<>'' then
      werr(StringGrid1.Cells[0,i]+'#'+StringGrid1.Cells[8,i],4);
    s:='';
    k:=2;
    while k<=6 do begin
      if StringGrid1.Cells[k,i]<>'' then
        s:=s+StringGrid1.Cells[k,i]+'='+StringGrid1.Cells[k+1,i]+'#';
      k:=k+2;
    end;
    if s<>'' then
      werr(s,4);
  end;
  geaendert:=false;
  close;

  formshow(self);
end;

function Berechnekosten(start,ende:TTime;provdr:string):real;
var
  dauer,hstart,hende:ttime;
  t,takt,help:real;
  i,pindex,tagesart,zeiteinheiten:integer;
  p:array [1..3] of real;
  zeit:array [1..3] of ttime;
  beintarif:bool;
begin
  dauer:=ende-start;    // 0,002679421972
  t:=dauer*86400;    // zeit in sekunden
  hstart:=frac(start);
  hende:=frac(ende);
  pindex:=0;
  for i:=1 to 10 do
    if provdr=provider[i] then
      pindex:=i;
  if pindex=0 then begin
    //showmessage('Provider '+provdr+' in den Einstellungen nicht gefunden !')
    frmtest.caption:='Watchy - unbekannter Provider';
    Berechnekosten:=0;
  end
  else begin
    tagesart:=0;  // normal
    i:=TagImJahr(start);
    if feiertag[i]<>0 then
      tagesart:=2; // feiertag
    if DayofWeek(start)=7 then
      tagesart:=1; // samstag
    if DayofWeek(start)=1 then
      tagesart:=2; // sonntag
    p[2]:=0;
    p[3]:=0;
    case tagesart of
      0: begin // normal
        p[1]:=preis[pindex,1];
        p[2]:=preis[pindex,1+4];
        p[3]:=preis[pindex,1+8];
        zeit[1]:=zeitraum[pindex,1];
        zeit[2]:=zeitraum[pindex,1+4];
        zeit[3]:=zeitraum[pindex,1+8];
      end;
      1: begin // samstag
        p[1]:=preis[pindex,2];
        p[2]:=preis[pindex,2+4];
        p[3]:=preis[pindex,2+8];
        zeit[1]:=zeitraum[pindex,2];
        zeit[2]:=zeitraum[pindex,2+4];
        zeit[3]:=zeitraum[pindex,2+8];
      end;
      2: begin // feiertag / sonntag
        p[1]:=preis[pindex,3];
        p[2]:=preis[pindex,3+4];
        p[3]:=preis[pindex,3+8];
        zeit[1]:=zeitraum[pindex,3];
        zeit[2]:=zeitraum[pindex,3+4];
        zeit[3]:=zeitraum[pindex,3+8];
      end;
    end;
    beintarif:=true;
    if p[2]>0 then
      beintarif:=false;
    takt:=taktung[pindex];  // 1 60
    help:=t/takt;           // anzahl zeiteinheiten
    zeiteinheiten:=trunc(int(help));  // ganzzahliger Anteil
    if frac(help) > 0 then
      inc(zeiteinheiten);
    if beintarif=true then
      Berechnekosten:=zeiteinheiten*takt*p[1]/100.0/60.0
    else begin
      if hstart<zeit[2] then // z.B. vor 8 Uhr
        Berechnekosten:=zeiteinheiten*takt*p[1]/100.0/60.0
      else if hstart<zeit[3] then // z.B. 8-18 Uhr
        Berechnekosten:=zeiteinheiten*takt*p[2]/100.0/60.0
      else               // z.B. nach 18 Uhr
        Berechnekosten:=zeiteinheiten*takt*p[3]/100.0/60.0;
    end;
  end;
end;

procedure TEinstell.btn_neuClick(Sender: TObject);
var
  i:integer;
begin
  i:=StringGrid1.rowcount;
  StringGrid1.rowcount:=i+3;
  StringGrid1.Cells[0,i]:='Provider';
  StringGrid1.Cells[1,i]:='Wochentag';
  StringGrid1.Cells[1,1+i]:='Samstag';
  StringGrid1.Cells[1,2+i]:='Feiertag';
  StringGrid1.Cells[2,i]:='00:00-24:00';
  StringGrid1.Cells[2,1+i]:='00:00-24:00';
  StringGrid1.Cells[2,2+i]:='00:00-24:00';
  StringGrid1.Cells[3,i]:='0,0';
  StringGrid1.Cells[3,1+i]:='0,0';
  StringGrid1.Cells[3,2+i]:='0,0';
  StringGrid1.Cells[8,i]:='60';
  StringGrid1.Cells[8,1+i]:='60';
  StringGrid1.Cells[8,2+i]:='60';
end;

procedure TEinstell.StringGrid1DblClick(Sender: TObject);
begin
  geaendert:=true;
end;

end.
